#pragma once

#include "GameObject.h"
#include "Team.h"
#include "Resource.h"

class Spiel;

class Base : public GameObject
{
private:
    int id;
    Team *team;
    int maxTime;
    bool inChange;
    Team *nextTeam;
    float leftTime;
    ResourceRegistry *resources;
    bool showTimer;
    Punkt timerPosition;
    int timerFarbe;
    TextRenderer *tr;

public:
    Base( ResourceRegistry *zResources, int id, int x, int y, int width, int height, bool showTimer, Punkt timerPosition, int timerFarbe, TextRenderer *tr, int maxTime = 10, Team * team = 0 );
    ~Base();
    void setTeam( Team *team, Spiel *zSpiel );
    void startChange( Team *team );
    void tick( double time, Spiel *zSpiel );
    void render( Bild &rObj ) override;
    int getId() const;
    Team *getTeam() const;
    Team *zTeam() const;
};