#pragma once


#include "Variablen.h"
#include "Array.h"
#include <TextFeld.h>
#include <Rahmen.h>


class Bestenliste : public Variable
{
private:
    RCArray< TextFeld > spalten;
    RCArray< TextFeld > zeilen;
    RCArray< RCArray< TextFeld > > werte;
    Schrift *schrift;
    LRahmen ram;
    int id;
    bool sichtbar;

    int getSpaltenBreite( int i ) const;

public:
    Bestenliste( int id, Schrift *schrift );
    ~Bestenliste();
    void setSichtbar( bool sichtbar );
    void addSpalte( const char *name );
    void addZeile( const char *name );
    void setWert( const char *spalte, const char *zeile, const char *wert );
    const char *getWert( const char *spalte, const char *zeile );
    void render( int x, int y, Bild &rObj );
    int getBreite() const;
    int getHeight() const;
};