#include "STKNachricht.h"
#include <cstring>

// Inhalt der STKNachricht Klasse aus STKNachricht.h
// Konstruktor
STKNachricht::STKNachricht( int ln, char *nachricht )
{
	verarbeitet = 0;
	this->ln = ln;
	this->nachricht = new char[ this->ln ];
    memcpy( this->nachricht, nachricht, ln );
	ref = 1;
}

// Destruktor
STKNachricht::~STKNachricht()
{
	delete[] nachricht;
}

// nicht constant
void STKNachricht::setVerarbeitet()
{
	verarbeitet = 1;
}

// constant
bool STKNachricht::istVerarbeitet() const
{
	return verarbeitet;
}

int STKNachricht::getLength() const
{
	return ln;
}

char *STKNachricht::getNachricht() const
{
	return nachricht;
}

// Reference Counting
STKNachricht *STKNachricht::getThis()
{
	ref++;
	return this;
}

STKNachricht *STKNachricht::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}